<html xmlns="https://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta http-equiv="Content-Language" content="zh-CN" />
<link href="../style/css/manual-zip.css" rel="stylesheet" media="all" type="text/css" title="Main stylesheet" />
<link href="../style/css/manual-zip-100pc.css" rel="alternate stylesheet" media="all" type="text/css" title="No Sidebar - Default font size" />
<link href="../style/css/manual-print.css" rel="stylesheet" media="print" type="text/css" />
<meta name="description" content="mod_headers － Apache 2.2 中文手册 [金步国作品集]">
<title>mod_headers － Apache 2.2 中文手册 [金步国]</title>
<script> var _hmt = _hmt || []; (function() { var hm = document.createElement("script"); hm.src = "https://hm.baidu.com/hm.js?2468a2c5d539e359902070bcd91865b1"; var s = document.getElementsByTagName("script")[0]; s.parentNode.insertBefore(hm, s); })(); </script>
</head>
<body><div id="page-header">
<p class="menu"><a href="../mod/index.html">模块索引</a> | <a href="../mod/directives.html">指令索引</a> | <a href="../faq/index.html">常见问题</a> | <a href="../glossary.html">词汇表</a> | <a href="../sitemap.html">站点导航</a></p><p class="apache">Apache HTTP Server 版本2.2</p><img alt="" src="../images/feather.gif" /></div>
<div class="up"><a href="./index.html"><img title="&lt;-" alt="&lt;-" src="../images/left.gif" /></a></div>
<div id="path"><a href="https://www.apache.org/">Apache</a> &gt; <a href="https://httpd.apache.org/">HTTP Server</a> &gt; <a href="https://httpd.apache.org/docs/">文档</a> &gt; <a href="../index.html">版本2.2</a> &gt; <a href="./index.html">模块</a></div>

<div id="translation-info">　　 <a href="../translator_announcement.html#thanks">致谢</a> | 本篇译者：<a href="https://www.jinbuguo.com/">金步国</a>(<a href="https://www.jinbuguo.com/">作品集</a>) | 本页最后更新：2006年10月20日</div>
<div id="page-content"><div id="preamble"><h1>Apache模块 mod_headers</h1>

<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="module">
<tr><th><a href="module-dict.html#Description">说明</a></th><td>允许通过配置文件控制任意的HTTP请求和应答头信息</td></tr>
<tr><th><a href="module-dict.html#Status">状态</a></th><td>扩展(E)</td></tr>
<tr><th><a href="module-dict.html#ModuleIdentifier">模块名</a></th><td>headers_module</td></tr>
<tr><th><a href="module-dict.html#SourceFile">源文件</a></th><td>mod_headers.c</td></tr>
<tr><th><a href="module-dict.html#Compatibility">兼容性</a></th><td><code class="directive"><a href="#requestheader">RequestHeader</a></code>仅在 Apache 2.0 中有效</td></tr>
</table>
<h3>概述</h3>

    <p>这个模块提供了一些指令用于控制和修改HTTP请求头和应答头。这些头可以被合并、替换、删除。</p>
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="order" id="order">处理顺序</a></h2>

    <p>由<code class="module"><a href="../mod/mod_headers.html">mod_headers</a></code>提供的指令几乎可以出现在配置文件的任何部分。并可以封装在<a href="../sections.html">配置段</a>中以限制其作用范围。</p>

    <p>指令的处理顺序很重要，它取决于指令本身在配置文件中的位置和所属<a href="../sections.html#mergin">配置段</a>在配置文件中的位置。下面的指令如果颠倒一下顺序将会导致完全不同的结果：</p>

    <div class="example"><p><code>
      RequestHeader append MirrorID "mirror 12"<br />
      RequestHeader unset MirrorID
    </code></p></div>

    <p>当前顺序下，<code>MirrorID</code>头不会被设置。若颠倒一下顺序，<code>MirrorID</code>头将被设为"mirror 12"。</p>
</div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="early" id="early">前处理和后处理</a></h2>
    <p><code class="module"><a href="../mod/mod_headers.html">mod_headers</a></code>可以应用在请求被处理之前或之后。通常的模式是"后处理"，也就是在请求处理完毕之后、发送应答之前设置应答头。[原文：when Request Headers are set immediately before running the content generator and Response Headers just as the response is sent down the wire.]在实际工作的服务器上应当始终使用"后处理"模式。</p>

    <p>"前处理"模式应当仅仅作为开发者使用的一种测试/调试辅助工具。可以在指令中使用<code>early</code>关键字启用"前处理"模式，此时将在处理请求之前设置请求头。这样就可以模拟各种不同的请求以协助调试。</p>

    <p>由于"前处理"模式的指令在将URL映射到文件系统之前就生效了，不能依赖于所请求的路径。所以"前处理"模式的指令只能用在主服务器和虚拟主机部分的配置中，而不能用于<code>&lt;Directory&gt;</code>或<code>&lt;Location&gt;</code>配置段中。</p>
</div><div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="section">
<h2><a name="examples" id="examples">示例</a></h2>

    <ol>
      <li>将所有以"TS"开头的请求头复制到应答头中：
        <div class="example"><p><code>
          Header echo ^TS
        </code></p></div>
      </li>

      <li>在应答中添加一个<code>MyHeader</code>头来包含服务端接受到请求的时间戳和经过多少时间以后才完成对该请求的处理并作出应答。这个头可以让客户端知道瓶颈位于服务端还是位于服务端和客户端之间的线路。
        <div class="example"><p><code>
          Header add MyHeader "%D %t"
        </code></p></div>

        <p>上面的设置将会添加如下应答头内容：</p>

        <div class="example"><p><code>
          MyHeader: D=3775428 t=991424704447256
        </code></p></div>
      </li>

      <li>向Joe问好(Hello)：
        <div class="example"><p><code>
          Header add MyHeader "Hello Joe. It took %D microseconds \<br />
          for Apache to serve this request."
        </code></p></div>

        <p>上面的设置将会添加如下应答头内容：</p>

        <div class="example"><p><code>
          MyHeader: Hello Joe. It took D=3775428 microseconds for Apache to serve this request.
        </code></p></div>
      </li>

      <li>当且仅当"MyRequestHeader"出现在请求头中的时候才在应答中发送"<code>MyHeader</code>"头。这个对根据特定的客户端构造特定的应答头很有用。注意，下面的例子需要<code class="module"><a href="../mod/mod_setenvif.html">mod_setenvif</a></code>模块的支持。
        <div class="example"><p><code>
          SetEnvIf MyRequestHeader value HAVE_MyRequestHeader<br />
          Header add MyHeader "%D %t mytext" env=HAVE_MyRequestHeader<br />
       </code></p></div>

       <p>如果请求中出现"<code>MyRequestHeader: value</code>"头，应答中将会包含下面的头：</p>

       <div class="example"><p><code>
         MyHeader: D=3775428 t=991424704447256 mytext
       </code></p></div>
      </li>
    </ol>
</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="Header" id="Header">Header</a> <a name="header" id="header">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>配置HTTP应答头</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>Header [<var>condition</var>] set|append|add|unset|echo <var>header</var> [<var>value</var>] [early|env=[!]<var>variable</var>]</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config, virtual host, directory, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Override">覆盖项</a></th><td>FileInfo</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>扩展(E)</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td>mod_headers</td></tr>
</table>
    <p>这个指令可以替换、合并、删除HTTP应答头。应答头紧跟在内容处理器和输出过滤器完工之后生成，这时候才能对头进行修改。</p>

    <p><var>condition</var>选项可以是<code>onsuccess</code>或<code>always</code> 。它决定了将对哪个内部头(internal header)表进行操作。<code>onsuccess</code>表示"<code>2<var>xx</var></code>"状态码，<code>always</code>表示所有状态码(包含"<code>2<var>xx</var></code>")。特别地，如果你想撤销由某个模块设置的头，你应当做做试验，以找到是那个表产生的影响。</p>

    <p>该指令执行的动作是由第二个参数决定的。这个参数取值范围如下：</p>

    <dl>
    <dt><code>set</code></dt>
    <dd>设置新的或修改已经存在的同名应答头。<var>value</var>可以是一个格式字符串。</dd>

    <dt><code>append</code></dt>
    <dd>向同名应答头添加新内容而不修改原来已经存在的旧内容。当向一个已经存在的头添加新值时，将用逗号与原来已经存在的旧值分开。这是向HTTP头赋以多个值的标准方法。</dd>

    <dt><code>add</code></dt>
    <dd>向应答中添加新的头而不修改原来已经存在的头(即使同名)。这将可能导致有两个或更多的应答头具有相同的名字，从而导致意想不到的后果，所以通常不使用这种方法而用<code>append</code>来代替它。</dd>

    <dt><code>unset</code></dt>
    <dd>去除应答中同名的头(若存在的话)。如果有多个头同名，则会被全部去除。<var>value</var>必须被省略。</dd>

    <dt><code>echo</code></dt>
    <dd>将请求中同名的头复制到应答中。<var>header</var>可以是一个<a class="glossarylink" href="../glossary.html#regex" title="see glossary">正则表达式</a>。<var>value</var>必须被省略。</dd>
    </dl>

    <p>这个参数后面必须要跟一个<var>header</var>名字(结尾的冒号可要可不要)。<code>set</code>, <code>append</code>, <code>add</code>, <code>unset</code>是大小写无关的。用于<code>echo</code>的<var>header</var>是大小写敏感的，并且可以是一个<a class="glossarylink" href="../glossary.html#regex" title="see glossary">正则表达式</a>。</p>

    <p>对于<code>add</code>, <code>append</code>, <code>set</code>来说，<var>value</var>是第三个参数。如果<var>value</var>包含空格则必须用双引号(")括起来。<var>value</var>可以是一个普通字符串或包含格式说明符的字符串，<var>value</var>支持下列格式字符串：</p>

    <table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="bordered">
<tr class="header"><th>格式</th><th>描述</th></tr>
<tr><td><code>%%</code></td><td>百分号(%)</td></tr>
<tr class="odd"><td><code>%t</code></td><td>接收到请求的微秒时间戳(相对于1970-1-1 00:00:00 UCT)，外加一个"<code>t=</code>"前缀。</td></tr>
<tr><td><code>%D</code></td><td>从接收到请求到完成对该请求的处理并作出应答共花费了多少微秒，外加一个"<code>D=</code>"前缀。</td></tr>
<tr class="odd"><td><code>%{FOOBAR}e</code></td><td><a href="../env.html">环境变量</a><code>FOOBAR</code>的内容</td></tr>
<tr><td><code>%{FOOBAR}s</code></td><td><a href="mod_ssl.html#envvars">SSL环境变量</a><code>FOOBAR</code>的内容(如果启用了<code class="module"><a href="../mod/mod_ssl.html">mod_ssl</a></code>)</td></tr>
</table>

    <div class="note"><h3>注意</h3>
      <p>"<code>%s</code>"格式符仅在Apache 2.1及以后的版本中可用。它可以代替"<code>%e</code>"以避免"<code>SSLOptions +StdEnvVars</code>"带来的额外开销。如果因为别的原因必须开启"<code>SSLOptions +StdEnvVars</code>"，那么"<code>%e</code>"将比"<code>%s</code>"更加合适。</p>
    </div>

    <p><code class="directive">Header</code>后面可以跟一个用于指定生效条件的额外参数(或者用<code>early</code>表示"<a href="#early">前处理</a>")。如果在"<code>env=<var>...</var></code>"参数中指定的<a href="../env.html">环境变量</a>存在(或用"<code>env=!<var>...</var></code>"表示不存在)，那么<code class="directive">Header</code>指令指定的动作将会生效，否则将不会生效。</p>

    <p>除非使用<a href="#early">early</a>模式，否则<code class="directive">Header</code>指令将在应答最后被发送到网络前处理。这意味着可以设置和改写绝大多数应答头，除了自己添加的应答头。</p>

</div>
<div class="top"><a href="#page-header"><img alt="top" src="../images/up.gif" /></a></div>
<div class="directive-section"><h2><a name="RequestHeader" id="RequestHeader">RequestHeader</a> <a name="requestheader" id="requestheader">指令</a></h2>
<table border="1" cellpadding="0" cellspacing="0" bordercolor="#AAAAAA" class="directive">
<tr><th><a href="directive-dict.html#Description">说明</a></th><td>配置HTTP请求头</td></tr>
<tr><th><a href="directive-dict.html#Syntax">语法</a></th><td><code>RequestHeader set|append|add|unset <var>header</var> [<var>value</var>] [early|env=[!]<var>variable</var>]</code></td></tr>
<tr><th><a href="directive-dict.html#Context">作用域</a></th><td>server config, virtual host, directory, .htaccess</td></tr>
<tr><th><a href="directive-dict.html#Override">覆盖项</a></th><td>FileInfo</td></tr>
<tr><th><a href="directive-dict.html#Status">状态</a></th><td>扩展(E)</td></tr>
<tr><th><a href="directive-dict.html#Module">模块</a></th><td>mod_headers</td></tr>
<tr><th><a href="directive-dict.html#Compatibility">兼容性</a></th><td>仅在 Apache 2.0 中有效</td></tr>
</table>
    <p>这个指令可以替换、合并、删除HTTP应答头。请求头将会在内容处理器运行之前被修改。修改的动作由第一个参数决定，其取值范围如下：</p>

    <dl>
    <dt><code>set</code></dt>
    <dd>设置新的或修改已经存在的同名请求头。</dd>

    <dt><code>append</code></dt>
    <dd>向同名请求头添加新内容而不修改原来已经存在的旧内容。当向一个已经存在的头添加新值时，将用逗号与原来已经存在的旧值分开。这是向HTTP头赋以多个值的标准方法。</dd>

    <dt><code>add</code></dt>
    <dd>向请求中添加新的头而不修改原来已经存在的头(即使同名)。这将可能导致有两个或更多的请求头具有相同的名字，从而导致意想不到的后果，所以通常不使用这种方法而用<code>append</code>来代替它。</dd>

    <dt><code>unset</code></dt>
    <dd>去除请求中同名的头(若存在的话)。如果有多个头同名，则会被全部去除。<var>value</var>必须被省略。</dd>
    </dl>

    <p>这些参数后面必须要跟一个<var>header</var>名(结尾的冒号可要可不要，且大小写无关)。对于<code>add</code>, <code>append</code>, <code>set</code>来说，<var>value</var>是第三个参数。如果<var>value</var>包含空格则必须用双引号(")括起来。对于<code>unset</code>来说则不需要<var>value</var>参数。<var>value</var>可以是一个普通字符串或包含格式说明符的字符串，格式字符串的用法与<code class="directive">Header</code>指令一样。</p>

    <p><code class="directive">RequestHeader</code>后面可以跟一个用于指定生效条件的额外参数(或者用<code>early</code>表示"<a href="#early">前处理</a>")。如果在"<code>env=<var>...</var></code>"参数中指定的<a href="../env.html">环境变量</a>存在(或用"<code>env=!<var>...</var></code>"表示不存在)，那么<code class="directive">RequestHeader</code>指令指定的动作将会生效，否则将不会生效。</p>

    <p>除非使用<a href="#early">early</a>模式，否则<code class="directive">RequestHeader</code>将在请求被处理之前生效。这样，由浏览器和Apache输入过滤器产生的请求头都可以被该指令处理。</p>

</div>
</div>
<div id="footer">
<p class="apache">本文允许自由的转载、引用、再分发，但必须保留译者署名并注明出处；详见：<a href="../translator_announcement.html#announcement">版权声明</a>。</p>
<p class="menu"><a href="../mod/index.html">模块索引</a> | <a href="../mod/directives.html">指令索引</a> | <a href="../faq/index.html">常见问题</a> | <a href="../glossary.html">词汇表</a> | <a href="../sitemap.html">站点导航</a></p></div>
</body></html>
